=== debian/changelog ===
apparmor (5.0.0~beta1-0ubuntu2) resolute; urgency=medium

  * Add patch to fix libapparmor Python aa_get_lsm_iface binding
    (LP: #2142788):
    - d/p/u/libapparmor-move-aa_get_lsm_iface-decl-in-libapparmor.patch
  * Add patches to fix parser tempfile umask (LP: #2142885):
    - d/p/u/0001-parser-set-umask-before-creating-temp-file.patch
    - d/p/u/0002-parser-restrict-umask-to-allow-only-user-permissions.patch
  * Add test for libapparmor feature prefix parse issue (LP 2105986):
    - d/p/u/libapparmor-add-test-for-libapparmor-features-prefix.patch

 -- Ryan Lee <ryan.lee@canonical.com>  Fri, 27 Feb 2026 09:48:42 -0800

apparmor (5.0.0~beta1-0ubuntu1) resolute; urgency=medium

  [ Alessandro Astone ]
  * d/tests: Update libreoffice profile names

  [ Ryan Lee ]
  * New upstream release.
  * debian/control: add libzstd-dev to list of dependencies
  * debian/libapparmor1.symbols: Add new libapparmor symbols to file
  * Refresh patches to apply to new release:
    - d/p/u/communitheme-snap-support.patch
    - d/p/u/profiles-grant-access-to-systemd-resolved.patch
  * Drop patches that were superseded upstream:
    - d/p/u/parser-fix-pam_apparmor-regression-test-failures.patch

 -- Ryan Lee <ryan.lee@canonical.com>  Thu, 19 Feb 2026 09:57:16 -0800
