=== debian/watch ===
version=4
opts="searchmode=plain, uversionmangle=s/-beta/~beta/; s/-alpha/~alpha/" \
https://gitlab.com/apparmor/apparmor/tags?sort=updated_desc \
-/archive/v?\d[\d.]+(?:-(?:alpha|beta)\d+)?/apparmor-@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate
